diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/wifi/model/wifi-default-protection-manager.h ns-3.44/src/wifi/model/wifi-default-protection-manager.h
--- ns-3.43/src/wifi/model/wifi-default-protection-manager.h	2024-10-09 16:41:10.128656900 -0700
+++ ns-3.44/src/wifi/model/wifi-default-protection-manager.h	2025-03-09 16:55:49.799372700 -0700
@@ -19,7 +19,7 @@
 class WifiMacHeader;
 
 /**
- * \ingroup wifi
+ * @ingroup wifi
  *
  * WifiDefaultProtectionManager is the default protection manager, which selects
  * the protection method for a frame based on its size.
@@ -28,8 +28,8 @@
 {
   public:
     /**
-     * \brief Get the type ID.
-     * \return the object TypeId
+     * @brief Get the type ID.
+     * @return the object TypeId
      */
     static TypeId GetTypeId();
 
@@ -45,9 +45,9 @@
     /**
      * Select the protection method for a single PSDU.
      *
-     * \param hdr the MAC header of the PSDU
-     * \param txParams the TX parameters describing the PSDU
-     * \return the selected protection method
+     * @param hdr the MAC header of the PSDU
+     * @param txParams the TX parameters describing the PSDU
+     * @return the selected protection method
      */
     virtual std::unique_ptr<WifiProtection> GetPsduProtection(
         const WifiMacHeader& hdr,
@@ -64,9 +64,9 @@
      * bandwidth equal to the minimum between the TX width of the DL MU PPDU and the
      * maximum channel width supported by the non-AP station.
      *
-     * \param mpdu the given MPDU
-     * \param txParams the TX parameters describing the current DL MU PPDU
-     * \return the new protection method or a null pointer if the protection method
+     * @param mpdu the given MPDU
+     * @param txParams the TX parameters describing the current DL MU PPDU
+     * @return the new protection method or a null pointer if the protection method
      *         is unchanged
      */
     virtual std::unique_ptr<WifiProtection> TryAddMpduToMuPpdu(Ptr<const WifiMpdu> mpdu,
@@ -80,15 +80,16 @@
      * occupying a bandwidth equal to the minimum between the TX width of the PPDU containing
      * the MU-RTS and the maximum channel width supported by the non-AP station.
      *
-     * \param mpdu the given Trigger Frame
-     * \param txParams the current TX parameters (just the TXVECTOR needs to be set)
-     * \return the protection method for the UL MU transmission solicited by the given Trigger Frame
+     * @param mpdu the given Trigger Frame
+     * @param txParams the current TX parameters (just the TXVECTOR needs to be set)
+     * @return the protection method for the UL MU transmission solicited by the given Trigger Frame
      */
     virtual std::unique_ptr<WifiProtection> TryUlMuTransmission(Ptr<const WifiMpdu> mpdu,
                                                                 const WifiTxParameters& txParams);
 
-    bool m_sendMuRts;        //!< true for sending an MU-RTS to protect DL MU PPDUs
-    bool m_singleRtsPerTxop; //!< true for using protection only once in a TXOP
+    bool m_sendMuRts;           //!< true for sending an MU-RTS to protect DL MU PPDUs
+    bool m_singleRtsPerTxop;    //!< true for using protection only once in a TXOP
+    bool m_skipMuRtsBeforeBsrp; //!< whether to skip MU-RTS before BSRP TF
 };
 
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/wifi/model/wifi-information-element.h ns-3.44/src/wifi/model/wifi-information-element.h
--- ns-3.43/src/wifi/model/wifi-information-element.h	2024-10-09 16:41:10.128656900 -0700
+++ ns-3.44/src/wifi/model/wifi-information-element.h	2025-03-09 16:55:49.799372700 -0700
@@ -198,7 +198,14 @@
 #define IE_QUIET_PERIOD_RESPONSE ((WifiInformationElementId)177)
 // 178 to 181 are reserved
 #define IE_ECPAC_POLICY ((WifiInformationElementId)182)
-// 183 to 190 are reserved
+#define IE_CLUSTER_TIME_OFFSET ((WifiInformationElementId)183)
+#define IE_INTRA_ACCESS_CATEGORY_PRIORITY ((WifiInformationElementId)184)
+#define IE_SCS_DESCRIPTOR ((WifiInformationElementId)185)
+#define IE_QLOAD_REPORT ((WifiInformationElementId)186)
+#define IE_HCCA_TXOP_UPDATE_COUNT ((WifiInformationElementId)187)
+#define IE_HIGHER_LAYER_STREAM_ID ((WifiInformationElementId)188)
+#define IE_GCR_GROUP_ADDRESS ((WifiInformationElementId)189)
+#define IE_ANTENNA_SECTOR_ID_PATTERN ((WifiInformationElementId)190)
 #define IE_VHT_CAPABILITIES ((WifiInformationElementId)191)
 #define IE_VHT_OPERATION ((WifiInformationElementId)192)
 #define IE_EXTENDED_BSS_LOAD ((WifiInformationElementId)193)
@@ -232,8 +239,8 @@
 #define IE_EXT_TID_TO_LINK_MAPPING_ELEMENT ((WifiInformationElementId)109)
 
 /**
- * \brief Information element, as defined in 802.11-2007 standard
- * \ingroup wifi
+ * @brief Information element, as defined in 802.11-2007 standard
+ * @ingroup wifi
  *
  * The IEEE 802.11 standard includes the notion of Information
  * Elements, which are encodings of management information to be
@@ -282,9 +289,9 @@
      * Serialize entire IE including Element ID and length fields. Handle
      * fragmentation of the IE if needed.
      *
-     * \param i an iterator which points to where the IE should be written.
+     * @param i an iterator which points to where the IE should be written.
      *
-     * \return an iterator
+     * @return an iterator
      */
     Buffer::Iterator Serialize(Buffer::Iterator i) const;
     /**
@@ -293,9 +300,9 @@
      * at the Element ID (i.e., the very first octet) of the correct type of
      * information element, otherwise this method will generate a fatal error.
      *
-     * \param i an iterator which points to where the IE should be read.
+     * @param i an iterator which points to where the IE should be read.
      *
-     * \return an iterator
+     * @return an iterator
      */
     Buffer::Iterator Deserialize(Buffer::Iterator i);
     /**
@@ -305,29 +312,29 @@
      * the Element ID is not the one that the given class is interested
      * in then it will return the same iterator.
      *
-     * \param i an iterator which points to where the IE should be read.
+     * @param i an iterator which points to where the IE should be read.
      *
-     * \return an iterator
+     * @return an iterator
      */
     Buffer::Iterator DeserializeIfPresent(Buffer::Iterator i);
     /**
      * Get the size of the serialized IE including Element ID and
      * length fields (for every element this IE is possibly fragmented into).
      *
-     * \return the size of the serialized IE in bytes
+     * @return the size of the serialized IE in bytes
      */
     uint16_t GetSerializedSize() const;
 
     // Each subclass must implement these pure virtual functions:
     /**
      * Get the wifi information element ID
-     * \returns the wifi information element ID
+     * @returns the wifi information element ID
      */
     virtual WifiInformationElementId ElementId() const = 0;
 
     /**
      * Get the wifi information element ID extension
-     * \returns the wifi information element ID extension
+     * @returns the wifi information element ID extension
      */
     virtual WifiInformationElementId ElementIdExt() const;
 
@@ -335,16 +342,16 @@
     /**
      * Generate human-readable form of IE
      *
-     * \param os output stream
+     * @param os output stream
      */
     virtual void Print(std::ostream& os) const;
     /**
      * Compare two IEs for equality by ID & Length, and then through
      * memcmp of serialised version
      *
-     * \param a another information element to compare with
+     * @param a another information element to compare with
      *
-     * \return true if the two IEs are equal,
+     * @return true if the two IEs are equal,
      *         false otherwise
      */
     virtual bool operator==(const WifiInformationElement& a) const;
@@ -353,18 +360,18 @@
     /**
      * Serialize an IE that needs to be fragmented.
      *
-     * \param i an iterator which points to where the IE should be written.
-     * \param size the size of the body of the IE
-     * \return an iterator pointing to past the IE that was serialized
+     * @param i an iterator which points to where the IE should be written.
+     * @param size the size of the body of the IE
+     * @return an iterator pointing to past the IE that was serialized
      */
     Buffer::Iterator SerializeFragments(Buffer::Iterator i, uint16_t size) const;
     /**
      * Deserialize the Information field of an IE. Also handle the case in which
      * the IE is fragmented.
      *
-     * \param i an iterator which points to where the Information field should be read.
-     * \param length the expected number of bytes to read
-     * \return an iterator pointing to past the IE that was deserialized
+     * @param i an iterator which points to where the Information field should be read.
+     * @param length the expected number of bytes to read
+     * @return an iterator pointing to past the IE that was deserialized
      */
     Buffer::Iterator DoDeserialize(Buffer::Iterator i, uint16_t length);
     /**
@@ -373,14 +380,14 @@
      * is the value that will appear in the second octet of the entire
      * IE - the length field - if the IE is not fragmented)
      *
-     * \return the length of serialized information
+     * @return the length of serialized information
      */
     virtual uint16_t GetInformationFieldSize() const = 0;
     /**
      * Serialize information (i.e., the body of the IE, not including
      * the Element ID and length octets)
      *
-     * \param start an iterator which points to where the information should
+     * @param start an iterator which points to where the information should
      *        be written.
      */
     virtual void SerializeInformationField(Buffer::Iterator start) const = 0;
@@ -388,20 +395,20 @@
      * Deserialize information (i.e., the body of the IE, not including
      * the Element ID and length octets)
      *
-     * \param start an iterator which points to where the information should be written.
-     * \param length the expected number of bytes to read
+     * @param start an iterator which points to where the information should be written.
+     * @param length the expected number of bytes to read
      *
-     * \return the number of bytes read
+     * @return the number of bytes read
      */
     virtual uint16_t DeserializeInformationField(Buffer::Iterator start, uint16_t length) = 0;
 };
 
 /**
- * \brief Stream insertion operator.
+ * @brief Stream insertion operator.
  *
- * \param os the output stream
- * \param element the Information Element
- * \returns a reference to the stream
+ * @param os the output stream
+ * @param element the Information Element
+ * @returns a reference to the stream
  */
 std::ostream& operator<<(std::ostream& os, const WifiInformationElement& element);
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/wifi/model/wifi-mac.cc ns-3.44/src/wifi/model/wifi-mac.cc
--- ns-3.43/src/wifi/model/wifi-mac.cc	2024-10-09 16:41:10.128656900 -0700
+++ ns-3.44/src/wifi/model/wifi-mac.cc	2025-03-09 16:55:49.803372600 -0700
@@ -146,6 +146,14 @@
                 UintegerValue(1024),
                 MakeUintegerAccessor(&WifiMac::GetMpduBufferSize, &WifiMac::SetMpduBufferSize),
                 MakeUintegerChecker<uint16_t>(1, 1024))
+            .AddAttribute(
+                "FrameRetryLimit",
+                "The maximum number of transmission attempts of a frame that are made before a "
+                "failure condition is indicated. This corresponds to the dot11ShortRetryLimit "
+                "parameter in the standard.",
+                UintegerValue(7),
+                MakeUintegerAccessor(&WifiMac::GetFrameRetryLimit, &WifiMac::SetFrameRetryLimit),
+                MakeUintegerChecker<uint32_t>(1, 65535))
             .AddAttribute("VO_MaxAmsduSize",
                           "Maximum length in bytes of an A-MSDU for AC_VO access class "
                           "(capped to 7935 for HT PPDUs and 11398 for VHT/HE/EHT PPDUs). "
@@ -282,12 +290,19 @@
                 UintegerValue(0),
                 MakeUintegerAccessor(&WifiMac::SetBkBlockAckInactivityTimeout),
                 MakeUintegerChecker<uint16_t>())
-            .AddTraceSource("MacTx",
-                            "A packet has been received from higher layers and is being processed "
-                            "in preparation for "
-                            "queueing for transmission.",
-                            MakeTraceSourceAccessor(&WifiMac::m_macTxTrace),
-                            "ns3::Packet::TracedCallback")
+            .AddAttribute("RobustAVStreamingSupported",
+                          "Whether or not Robust Audio Video Streaming is supported (only allowed "
+                          "for AP STAs or non-AP that are HT capable).",
+                          BooleanValue(false),
+                          MakeBooleanAccessor(&WifiMac::SetRobustAVStreamingSupported,
+                                              &WifiMac::GetRobustAVStreamingSupported),
+                          MakeBooleanChecker())
+            .AddTraceSource(
+                "MacTx",
+                "A packet has been received by the WifiNetDevice and is about to be enqueued; "
+                "it has a LlcSnapHeader prepended but not yet a WifiMacHeader.",
+                MakeTraceSourceAccessor(&WifiMac::m_macTxTrace),
+                "ns3::Packet::TracedCallback")
             .AddTraceSource(
                 "MacTxDrop",
                 "A packet has been dropped in the MAC layer before being queued for transmission. "
@@ -751,6 +766,9 @@
         MakeCallback(&MpduTracedCallback::operator(), &m_nackedMpduCallback));
     edcaIt->second->SetDroppedMpduCallback(
         MakeCallback(&DroppedMpduTracedCallback::operator(), &m_droppedMpduCallback));
+    edcaIt->second->GetWifiMacQueue()->TraceConnectWithoutContext(
+        "Expired",
+        MakeCallback(&WifiMac::NotifyRsmOfExpiredMpdu, this));
 }
 
 void
@@ -1051,6 +1069,7 @@
     for (auto managerIt = stationManagers.cbegin(); auto& [id, link] : m_links)
     {
         link->stationManager = *managerIt++;
+        link->stationManager->SetLinkId(id);
     }
 
     CompleteConfig();
@@ -1109,6 +1128,10 @@
     {
         link.channelAccessManager->SetLinkId(id);
     }
+    if (link.stationManager)
+    {
+        link.stationManager->SetLinkId(id);
+    }
 }
 
 std::optional<uint8_t>
@@ -1298,6 +1321,12 @@
     NS_ABORT_MSG_IF(dir == WifiDirection::BOTH_DIRECTIONS,
                     "Cannot request TID-to-Link mapping for both directions");
 
+    if (!GetWifiRemoteStationManager(linkId)->GetMldAddress(mldAddr).has_value())
+    {
+        // the link has not been setup
+        return false;
+    }
+
     const auto& mappings =
         (dir == WifiDirection::DOWNLINK ? m_dlTidLinkMappings : m_ulTidLinkMappings);
 
@@ -1306,7 +1335,7 @@
     if (it == mappings.cend())
     {
         // TID-to-link mapping was not negotiated, TIDs are mapped to all setup links
-        return GetWifiRemoteStationManager(linkId)->GetMldAddress(mldAddr).has_value();
+        return true;
     }
 
     auto linkSetIt = it->second.find(tid);
@@ -1315,7 +1344,7 @@
     {
         // If there is no successfully negotiated TID-to-link mapping for a TID, then the TID
         // is mapped to all setup links for DL and UL (Sec. 35.3.7.1.3 of 802.11be D3.1)
-        return GetWifiRemoteStationManager(linkId)->GetMldAddress(mldAddr).has_value();
+        return true;
     }
 
     return std::find(linkSetIt->second.cbegin(), linkSetIt->second.cend(), linkId) !=
@@ -1670,6 +1699,37 @@
 }
 
 void
+WifiMac::NotifyRsmOfExpiredMpdu(Ptr<const WifiMpdu> mpdu)
+{
+    NS_LOG_FUNCTION(this << *mpdu);
+
+    const auto& hdr = mpdu->GetHeader();
+    const auto remoteAddr = hdr.GetAddr1();
+
+    if (remoteAddr.IsGroup() || hdr.IsCtl() || !hdr.IsRetry() || mpdu->IsInFlight())
+    {
+        return; // nothing to do
+    }
+
+    std::optional<Mac48Address> optAddr;
+    for (const auto& [id, link] : m_links)
+    {
+        if (link->stationManager->GetMldAddress(remoteAddr) == remoteAddr)
+        {
+            // this is a link setup with a remote MLD and remoteAddr is the MLD address
+            optAddr = link->feManager->GetAddress(); // use local address of this setup link
+        }
+    }
+
+    const auto localAddr =
+        optAddr.value_or(GetNLinks() == 1 ? m_address : DoGetLocalAddress(remoteAddr));
+    const auto linkId = GetLinkIdByAddress(localAddr);
+    NS_ASSERT_MSG(linkId.has_value(), "No link with address " << localAddr);
+
+    GetLink(*linkId).stationManager->ReportFinalDataFailed(mpdu);
+}
+
+void
 WifiMac::Enqueue(Ptr<Packet> packet, Mac48Address to)
 {
     NS_LOG_FUNCTION(this << packet << to);
@@ -1842,12 +1902,15 @@
 }
 
 WifiMac::OriginatorAgreementOptConstRef
-WifiMac::GetBaAgreementEstablishedAsOriginator(Mac48Address recipient, uint8_t tid) const
+WifiMac::GetBaAgreementEstablishedAsOriginator(Mac48Address recipient,
+                                               uint8_t tid,
+                                               std::optional<Mac48Address> gcrGroupAddr) const
 {
     // BA agreements are indexed by the MLD address if ML setup was performed
     recipient = GetMldAddress(recipient).value_or(recipient);
 
-    auto agreement = GetQosTxop(tid)->GetBaManager()->GetAgreementAsOriginator(recipient, tid);
+    auto agreement =
+        GetQosTxop(tid)->GetBaManager()->GetAgreementAsOriginator(recipient, tid, gcrGroupAddr);
     if (!agreement || !agreement->get().IsEstablished())
     {
         return std::nullopt;
@@ -1856,11 +1919,13 @@
 }
 
 WifiMac::RecipientAgreementOptConstRef
-WifiMac::GetBaAgreementEstablishedAsRecipient(Mac48Address originator, uint8_t tid) const
+WifiMac::GetBaAgreementEstablishedAsRecipient(Mac48Address originator,
+                                              uint8_t tid,
+                                              std::optional<Mac48Address> gcrGroupAddr) const
 {
     // BA agreements are indexed by the MLD address if ML setup was performed
     originator = GetMldAddress(originator).value_or(originator);
-    return GetQosTxop(tid)->GetBaManager()->GetAgreementAsRecipient(originator, tid);
+    return GetQosTxop(tid)->GetBaManager()->GetAgreementAsRecipient(originator, tid, gcrGroupAddr);
 }
 
 BlockAckType
@@ -2033,6 +2098,19 @@
 }
 
 void
+WifiMac::SetFrameRetryLimit(uint32_t limit)
+{
+    NS_LOG_FUNCTION(this << limit);
+    m_frameRetryLimit = limit;
+}
+
+uint32_t
+WifiMac::GetFrameRetryLimit() const
+{
+    return m_frameRetryLimit;
+}
+
+void
 WifiMac::SetVoBlockAckThreshold(uint8_t threshold)
 {
     NS_LOG_FUNCTION(this << +threshold);
@@ -2115,24 +2193,22 @@
 ExtendedCapabilities
 WifiMac::GetExtendedCapabilities() const
 {
-    NS_LOG_FUNCTION(this);
     ExtendedCapabilities capabilities;
-    // TODO: to be completed
+    capabilities.m_robustAvStreaming = GetRobustAVStreamingSupported();
     return capabilities;
 }
 
 HtCapabilities
 WifiMac::GetHtCapabilities(uint8_t linkId) const
 {
-    NS_LOG_FUNCTION(this << +linkId);
     NS_ASSERT(GetHtSupported(linkId));
     HtCapabilities capabilities;
 
     auto phy = GetWifiPhy(linkId);
     Ptr<HtConfiguration> htConfiguration = GetHtConfiguration();
-    bool sgiSupported = htConfiguration->GetShortGuardIntervalSupported();
-    capabilities.SetLdpc(htConfiguration->GetLdpcSupported());
-    capabilities.SetSupportedChannelWidth(htConfiguration->Get40MHzOperationSupported() ? 1 : 0);
+    bool sgiSupported = htConfiguration->m_sgiSupported;
+    capabilities.SetLdpc(htConfiguration->m_ldpcSupported);
+    capabilities.SetSupportedChannelWidth(htConfiguration->m_40MHzSupported ? 1 : 0);
     capabilities.SetShortGuardInterval20(sgiSupported);
     capabilities.SetShortGuardInterval40(sgiSupported);
     // Set Maximum A-MSDU Length subfield
@@ -2160,9 +2236,10 @@
         capabilities.SetRxMcsBitmask(mcs.GetMcsValue());
         uint8_t nss = (mcs.GetMcsValue() / 8) + 1;
         NS_ASSERT(nss > 0 && nss < 5);
-        uint64_t dataRate = mcs.GetDataRate(htConfiguration->Get40MHzOperationSupported() ? 40 : 20,
-                                            NanoSeconds(sgiSupported ? 400 : 800),
-                                            nss);
+        uint64_t dataRate =
+            mcs.GetDataRate(htConfiguration->m_40MHzSupported ? MHz_u{40} : MHz_u{20},
+                            NanoSeconds(sgiSupported ? 400 : 800),
+                            nss);
         if (dataRate > maxSupportedRate)
         {
             maxSupportedRate = dataRate;
@@ -2183,18 +2260,16 @@
 VhtCapabilities
 WifiMac::GetVhtCapabilities(uint8_t linkId) const
 {
-    NS_LOG_FUNCTION(this << +linkId);
     NS_ASSERT(GetVhtSupported(linkId));
     VhtCapabilities capabilities;
 
     auto phy = GetWifiPhy(linkId);
     Ptr<HtConfiguration> htConfiguration = GetHtConfiguration();
-    NS_ABORT_MSG_IF(!htConfiguration->Get40MHzOperationSupported(),
+    NS_ABORT_MSG_IF(!htConfiguration->m_40MHzSupported,
                     "VHT stations have to support 40 MHz operation");
     Ptr<VhtConfiguration> vhtConfiguration = GetVhtConfiguration();
-    bool sgiSupported = htConfiguration->GetShortGuardIntervalSupported();
-    capabilities.SetSupportedChannelWidthSet(vhtConfiguration->Get160MHzOperationSupported() ? 1
-                                                                                             : 0);
+    bool sgiSupported = htConfiguration->m_sgiSupported;
+    capabilities.SetSupportedChannelWidthSet(vhtConfiguration->m_160MHzSupported ? 1 : 0);
     // Set Maximum MPDU Length subfield
     uint16_t maxAmsduSize =
         std::max({m_voMaxAmsduSize, m_viMaxAmsduSize, m_beMaxAmsduSize, m_bkMaxAmsduSize});
@@ -2217,7 +2292,7 @@
     // The maximum A-MPDU length in VHT capabilities elements ranges from 2^13-1 to 2^20-1
     capabilities.SetMaxAmpduLength(std::min(std::max(maxAmpduLength, 8191U), 1048575U));
 
-    capabilities.SetRxLdpc(htConfiguration->GetLdpcSupported());
+    capabilities.SetRxLdpc(htConfiguration->m_ldpcSupported);
     capabilities.SetShortGuardIntervalFor80Mhz(sgiSupported);
     capabilities.SetShortGuardIntervalFor160Mhz(sgiSupported);
     uint8_t maxMcs = 0;
@@ -2238,7 +2313,7 @@
         capabilities.SetTxMcsMap(maxMcs, nss);
     }
     uint64_t maxSupportedRateLGI = 0; // in bit/s
-    MHz_u maxWidth = vhtConfiguration->Get160MHzOperationSupported() ? 160 : 80;
+    const auto maxWidth = vhtConfiguration->m_160MHzSupported ? MHz_u{160} : MHz_u{80};
     for (const auto& mcs : phy->GetMcsList(WIFI_MOD_CLASS_VHT))
     {
         if (!mcs.IsAllowed(maxWidth, 1))
@@ -2265,7 +2340,6 @@
 HeCapabilities
 WifiMac::GetHeCapabilities(uint8_t linkId) const
 {
-    NS_LOG_FUNCTION(this << +linkId);
     NS_ASSERT(GetHeSupported());
     HeCapabilities capabilities;
 
@@ -2274,8 +2348,7 @@
     Ptr<VhtConfiguration> vhtConfiguration = GetVhtConfiguration();
     Ptr<HeConfiguration> heConfiguration = GetHeConfiguration();
     uint8_t channelWidthSet = 0;
-    if ((htConfiguration->Get40MHzOperationSupported()) &&
-        (phy->GetPhyBand() == WIFI_PHY_BAND_2_4GHZ))
+    if ((htConfiguration->m_40MHzSupported) && (phy->GetPhyBand() == WIFI_PHY_BAND_2_4GHZ))
     {
         channelWidthSet |= 0x01;
     }
@@ -2284,13 +2357,13 @@
     {
         channelWidthSet |= 0x02;
     }
-    if ((vhtConfiguration->Get160MHzOperationSupported()) &&
+    if ((vhtConfiguration->m_160MHzSupported) &&
         ((phy->GetPhyBand() == WIFI_PHY_BAND_5GHZ) || (phy->GetPhyBand() == WIFI_PHY_BAND_6GHZ)))
     {
         channelWidthSet |= 0x04;
     }
     capabilities.SetChannelWidthSet(channelWidthSet);
-    capabilities.SetLdpcCodingInPayload(htConfiguration->GetLdpcSupported());
+    capabilities.SetLdpcCodingInPayload(htConfiguration->m_ldpcSupported);
     if (heConfiguration->GetGuardInterval().GetNanoSeconds() == 800)
     {
         // todo: We assume for now that if we support 800ns GI then 1600ns GI is supported as well
@@ -2358,7 +2431,6 @@
 EhtCapabilities
 WifiMac::GetEhtCapabilities(uint8_t linkId) const
 {
-    NS_LOG_FUNCTION(this << +linkId);
     NS_ASSERT(GetEhtSupported());
     EhtCapabilities capabilities;
 
@@ -2401,7 +2473,7 @@
 
     const uint8_t maxTxNss = phy->GetMaxSupportedTxSpatialStreams();
     const uint8_t maxRxNss = phy->GetMaxSupportedRxSpatialStreams();
-    if (auto htConfig = GetHtConfiguration(); !htConfig->Get40MHzOperationSupported())
+    if (auto htConfig = GetHtConfiguration(); !htConfig->m_40MHzSupported)
     {
         for (auto maxMcs : {7, 9, 11, 13})
         {
@@ -2429,7 +2501,7 @@
                 phy->IsMcsSupported(WIFI_MOD_CLASS_EHT, maxMcs) ? maxTxNss : 0);
         }
     }
-    if (auto vhtConfig = GetVhtConfiguration(); vhtConfig->Get160MHzOperationSupported())
+    if (auto vhtConfig = GetVhtConfiguration(); vhtConfig->m_160MHzSupported)
     {
         for (auto maxMcs : {9, 11, 13})
         {
@@ -2498,4 +2570,19 @@
     return maxSize;
 }
 
+void
+WifiMac::SetRobustAVStreamingSupported(bool enable)
+{
+    NS_LOG_FUNCTION(this << enable);
+    m_robustAVStreamingSupported = enable;
+}
+
+bool
+WifiMac::GetRobustAVStreamingSupported() const
+{
+    NS_ASSERT_MSG(!m_robustAVStreamingSupported || GetDevice()->GetHtConfiguration(),
+                  "Robust AV Streaming requires STA to be HT-capable");
+    return m_robustAVStreamingSupported;
+}
+
 } // namespace ns3
